/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package bdd;

import bean.Dispo;
import bean.Pompier;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.logging.Level;
import java.util.logging.Logger;
import util.TrmtDate;

/**
 *
 * @author clementine.desrucques
 */
public class DispoMySql {
    private final Connection theConnection = Connexion.getConnect("localhost",
            "sdis29",
            "adminBDsdis",
            "mdpBDsdis"); 

    public ArrayList<Dispo> getLesDispo(Calendar[] lesDates, String[] lesPeriodes) {
        ArrayList<Dispo> lesP = new ArrayList<>();
        Dispo uneDispo;

        /* a. Initialisation de la collection lesVentil pour la période, 
            création d'une ventil par salarié, par date et période 
         */
        int indiceDateFin = lesDates.length - 1;
        Pompier leP;
        PompierMySQL sm = new PompierMySQL();
        ArrayList<Pompier> lesPom = sm.readAll();
        for (Pompier unP : lesPom) {
            for (Calendar uneDate : lesDates) {
                for (String unePeriode : lesPeriodes) {
                    uneDispo = new Dispo(uneDate, unePeriode, unP);
                    lesP.add(uneDispo);
                }
            }
        }

        /* b) Maj de la collection lesVentil        
         */
        readAll(lesPomp, lesDates[0], lesDates[indiceDateFin]);
        //System.out.println("lesVentil : " + lesVentil);
        return lesPomp;
    }

    public void readAll(ArrayList<Pompier> lesPomp, Calendar d1, Calendar d2) {
        Pompier leP;
        Dispo uneDispo;
        Dispo laDispoTrouvee;
        String sql = "SELECT * FROM gardes "
                + "INNER JOIN pompier on idPompier = id "
                + "WHERE jourGarde BETWEEN ? and ?;";
        try {
            PreparedStatement prepStmt = theConnection.prepareStatement(sql);
            prepStmt.setDate(1, TrmtDate.getSQLDate(d1));
            prepStmt.setDate(2, TrmtDate.getSQLDate(d2));
            ResultSet resultat = prepStmt.executeQuery();
            while (resultat.next()) {
                leP = new Pompier(
                        resultat.getCaserne("laCaserne"),
                        resultat.getInt("id"),
                        resultat.getString("nom"),
                        resultat.getString("prenom"),
                        resultat.getParametre("leStatut"),
                        resultat.getParametre("leType"),
                        resultat.getString("mail"),
                        resultat.getString("login"),
                        resultat.getString("mdp"),
                        resultat.getString("adresse"),
                        resultat.getString("cp"),
                        resultat.getString("ville"),
                        resultat.getString("bip"),
                        resultat.getParametre("leGrade"),
                        resultat.getString("commentaire")
                );
                uneDispo = new Dispo(TrmtDate.getCalDate(resultat.getDate("jourVentil")),
                        resultat.getString("periode"),
                        leP);
                // Recherche si unpompier existe dans les Pompier
                int indice = lesDispo.indexOf(uneDispo);
                if (indice > -1) {
                    laDispoTrouvee = lesDispo.get(indice);
                    laDispoTrouvee.setActivite(resultat.getInt("dispo"));
                    laDispoTrouvee.setIsInBD(true);
                }
            }
            prepStmt.close();
            resultat.close();
        } catch (SQLException ex) {
            System.out.println("SQLExeption : " + ex.getMessage());
            System.out.println("SQLState : " + ex.getSQLState());
            System.out.println("Code erreur : " + ex.getErrorCode());
        }
    }
    /**
     * Suppression de la ventilation passé en param
     * @param v : ventilation
     * @return : nb lignes supprimées
     */
    public int delete(Dispo p) {
        int nbMaj = -1;
        String sql = "DELETE FROM gardes "
                + "WHERE idPompier = ? AND"
                + "periode = ? AND"
                + "jourGarde = ?;";
        try {
            PreparedStatement prepStmt = theConnection.prepareStatement(sql);
            prepStmt.setInt(1, p.getPompier().getId());
            prepStmt.setString(2, p.getPeriode());
            prepStmt.setDate(3, TrmtDate.getSQLDate(p.getJourVentil()));
            nbMaj= prepStmt.executeUpdate();
            
            } catch (SQLException ex) {
            System.out.println("SQLExeption : " + ex.getMessage());
            System.out.println("SQLState : " + ex.getSQLState());
            System.out.println("Code erreur : " + ex.getErrorCode());
        }
            
            return nbMaj;
        }
    

    public int update(Dispo v) {

        int nbMAJ = -1;
        String sql = "UPDATE gardes "
                + "SET ventil = ? "
                + "WHERE idPompier = ? "
                + "AND jourGarde = ? "
                + "AND periode = ?";
        try {
            PreparedStatement prepStmt = theConnection.prepareStatement(sql);
            prepStmt.setInt(1, v.getActivite());
            prepStmt.setInt(2, v.getPompier().getId());
            prepStmt.setDate(3, TrmtDate.getSQLDate(v.getJourVentil()));
            prepStmt.setString(4, v.getPeriode());
            System.out.println("update : " + prepStmt);
            nbMAJ = prepStmt.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(DispoMySql.class.getName()).log(Level.SEVERE, null, ex);
        }
        return nbMAJ;
    }
    /**
     * Création d'un ventil
     * @param v : ventil à créer
     * @return : id du ventil
     */
    public int create(Dispo v) {
        int nbCre = -1;
        String sql = "INSERT INTO gardes "
                + "(jourGarde, idPompier, periode, ventil)"
                + "VALUES (?, ?, ?, ?);";
        try {
            PreparedStatement prepStmt = theConnection.prepareStatement(sql);
            prepStmt.setDate(1, TrmtDate.getSQLDate(v.getJourVentil()));
            prepStmt.setString(2, v.getPeriode());
            prepStmt.setInt(3, v.getPompier().getId());
            prepStmt.setInt(4, v.getActivite());
            int nbLigne= prepStmt.executeUpdate();
            if (nbLigne > 0) {
                ResultSet result = prepStmt.getGeneratedKeys();
                if (result.next()) {
                    nbCre = result.getInt(1);
                }
            }
            
            } catch (SQLException ex) {
            System.out.println("SQLExeption : " + ex.getMessage());
            System.out.println("SQLState : " + ex.getSQLState());
            System.out.println("Code erreur : " + ex.getErrorCode());
        }
            
            return nbCre;
    }
}
